using System;
using PolygonLib;

namespace WheelLib
{
    public class Wheel
    {
        private int teeth;
        private Point cent;
        private Polygon body;
        public Wheel(int teeth, double r)
        {
            double rMax, rMin, alpha, rr, x, y;
            rr = teeth / 2.0;
            alpha = Math.PI / (2 * teeth);
            rMin = rr - 1;
            rMax = rr + 1;
            this.teeth = teeth;
            this.cent = new Point(0, 0);
            this.body = new Polygon();
            for (int i = 0; i < teeth; i++)
            {
                x = rMin * Math.Cos(-1.5 * alpha + 4 * alpha * i);
                y = rMin * Math.Sin(-1.5 * alpha + 4 * alpha * i);
                this.body.AddPoint(new Point(x, y));
                x = rMax * Math.Cos(-0.5 * alpha + 4 * alpha * i);
                y = rMax * Math.Sin(-0.5 * alpha + 4 * alpha * i);
                this.body.AddPoint(new Point(x, y));
                x = rMax * Math.Cos(0.5 * alpha + 4 * alpha * i);
                y = rMax * Math.Sin(0.5 * alpha + 4 * alpha * i);
                this.body.AddPoint(new Point(x, y));
                x = rMin * Math.Cos(1.5 * alpha + 4 * alpha * i);
                y = rMin * Math.Sin(1.5 * alpha + 4 * alpha * i);
                this.body.AddPoint(new Point(x, y));

            }
            this.body.Scale(r / rr, r / rr);
        }
        public void Rotate(double angle)
        {
            this.body.Rotate(this.cent, angle);
        }
        public void Move(double dX, double dY)
        {
            this.body.Move(dX, dY);
            this.cent.SetX(this.cent.GetX() + dX);
            this.cent.SetY(this.cent.GetY() + dY);
        }
    }
}
